<template>
  <v-card class="mx-auto" max-width="100%">
    <confirmation-modal
      :is-open="openModal"
      :modal-text="modalText"
      text-button="GUARDAR"
      @confirm="confirmRegister"
      @cancel="cancelRegister"
    />
    <v-card-subtitle class="pb-0">
      <image-field
        v-model="specialist.user.image"
        :disabled="disabled_user_info"
        :validation="imageValidation"
        :url-image="specialist.profileImage"
      />
      <v-divider />
      <v-form ref="form" lazy-validation>
        <v-container fluid>
          <select-field
            v-model="specialist.user.typeDocument"
            :items="typesDocument"
            field-name="Tipo de documento"
            @selectChange="changeSELECT"
          />
          <register-field-validation
            v-if="specialist.user.typeDocument==='DNI'"
            v-model="specialist.user.document"
            field-name="DNI"
            :validation="DNIValidation"
            place-holder="Ingrese DNI"
            @inputChange="changeDNI"
          />
          <register-field-validation
            v-if="specialist.user.typeDocument==='CARNET EXTRANJERÍA'"
            v-model="specialist.user.document"
            field-name="Carnet de extranjería"
            :validation="carnetValidation"
            place-holder="Ingrese Carnet de extranjería"
            @inputChange="changeCarnetOrPassport"
          />
          <register-field-validation
            v-if="specialist.user.typeDocument==='PASAPORTE'"
            v-model="specialist.user.document"
            field-name="Pasaporte"
            :validation="passportValidation"
            place-holder="Ingrese Pasaporte"
            @inputChange="changeCarnetOrPassport"
          />
          <register-field-validation
            v-model="specialist.user.name"
            :disabled="disabled_user_info || typeDocumentSelected=='DNI'"
            field-name="Nombre"
            :validation="nameValidation"
            place-holder="Ingrese Nombre"
          />
          <register-field-validation
            v-model="specialist.user.fatherLastname"
            :disabled="disabled_user_info || typeDocumentSelected=='DNI'"
            field-name="Apellido Paterno"
            :validation="fatherLastnameValidation"
            place-holder="Ingrese Apellido Paterno"
          />
          <register-field-validation
            v-model="specialist.user.motherLastname"
            :disabled="disabled_user_info || typeDocumentSelected=='DNI'"
            field-name="Apellido Materno "
            :validation="motherLastNameValidation"
            place-holder="Ingrese Apellido Materno"
          />
          <email-field
            v-model="specialist.email"
            :disabled="disabled_user_info"
            field-name="Correo"
            :validation="emailValidation"
          />
          <register-field-validation
            v-model="specialist.phoneNumber"
            :disabled="disabled_user_info"
            field-name="Celular"
            :validation="phoneValidation"
            place-holder="Ingrese Número Celular"
            :obligatory="false"
          />
          <directions-field
            v-model="specialist.address"
            :disabled="disabled_user_info"
            field-name="Domicilio"
            place-holder="Ingrese Domicilio"
            :obligatory="false"
          />
          <picker-field
            v-model="specialist.user.birthdate"
            :disabled="disabled_user_info"
            field-name="Fecha de Nacimiento"
            :max="$config.birthdateValidation"
            :validation="birthDateValidation"
          />

          <register-field-validation
            v-model="specialist.specialty"
            :disabled="disabled_user_info"
            field-name="Especialidad"
            place-holder="Ingrese Especialidad"
          />
        </v-container>
      </v-form>
    </v-card-subtitle>
    <buttons-register-form
      @saveUser="handleRegisterSpecialist"
      @cancel="cancelForm"
    />
    <br>
    <v-snackbar
      v-model="snackBar.show"
      :color="snackBar.color"
      text
      top
    >
      {{ snackBar.text }}
      <template #action="{ attrs }">
        <v-btn
          color="blue"
          text
          v-bind="attrs"
          @click="snackBar.show = false"
        >
          <v-icon>mdi-window-close</v-icon>
        </v-btn>
      </template>
    </v-snackbar>
  </v-card>
</template>

<script>
import { mapActions, mapState, mapGetters } from 'vuex';
import {
  DNIRules,
  nameRules,
  fatherLastnameRules,
  motherLastnameRules,
  emailRules,
  imageFileRules,
  phoneRules, carnetRules, passportRules,
  birthDateRules,
} from '@/helpers/validation';
import RegisterFieldValidation from '~/components/InputField/RegisterFieldValidation';
import PickerField from '~/components/InputField/PickerField';
import SelectField from '~/components/InputField/SelectField.vue';
import ButtonsRegisterForm from '~/components/InputField/ButtonsRegisterForm.vue';
import imageField from '~/components/InputField/ImageField';
import ConfirmationModal from '~/components/register/confirmationModal';

import DirectionsField from '~/components/InputField/DirectionsField';
import EmailField from '~/components/InputField/EmailField';

export default {
  name: 'EditSpecialist',
  components: {
    RegisterFieldValidation,
    PickerField,
    ButtonsRegisterForm,
    imageField,
    ConfirmationModal,
    SelectField,
    DirectionsField,
    EmailField,
  },
  data: () => ({
    typeDocumentSelected: 'DNI',
    typesDocument: ['CARNET EXTRANJERÍA', 'DNI', 'PASAPORTE'],
    disabled_user_info: false,
    isValidForm: false,
    DNIValidation: DNIRules,
    carnetValidation: carnetRules,
    passportValidation: passportRules,
    nameValidation: nameRules,
    fatherLastnameValidation: fatherLastnameRules,
    motherLastNameValidation: motherLastnameRules,
    emailValidation: emailRules,
    imageValidation: imageFileRules,
    phoneValidation: phoneRules,
    birthdateValidation: birthDateRules,
    isDocumentRegistered: false,
    openModal: false,
    modalText: '¿Estás seguro que deseas guardar los cambios?',
    snackBar: {
      show: false,
      color: '',
      text: '',
    },
    specialist: {
      user: {
        image: null,
      },
    },
  }),

  computed: {
    ...mapState({
      checkedSpecialist: state => state.specialists.checkedSpecialist,
    }),
    ...mapGetters({
      storedSpecialist: 'specialists/getOneSpecialist',
    }),
  },
  async mounted() {
    await this.getASpecialist();
  },
  methods: {
    ...mapActions({
      editSpecialist: 'specialists/editSpecialist',
      getSpecialists: 'specialists/getSpecialists',
      getSpecialist: 'specialists/getSpecialist',
      checkedInformationSpecialist: 'specialists/checkedInformationSpecialist',
    }),
    async confirmRegister() {
      await this.register(this.specialist);
      await this.$router.push('/especialistas');
    },

    async getASpecialist() {
      await this.getSpecialist({ uuid: this.$route.params.id });
      this.specialist = JSON.parse(JSON.stringify(this.storedSpecialist));
      if (this.specialist.user.typeDocument === 'CARNET') {
        this.specialist.user.typeDocument = 'CARNET EXTRANJERÍA';
      }
    },
    cancelRegister() {
      this.openModal = false;
    },

    handleRegisterSpecialist() {
      if (!this.isDocumentRegistered) {
        if (this.$refs.form.validate()) {
          this.specialist.user.typeDocument = this.typeDocumentSelected;
          this.openModal = true;
        }
      } else {
        this.setNackBar('CAMBIAR ' + this.typeDocumentSelected + '. Ya existe un especialista registrado con el documento ingresado', 'error', true);
      }
    },
    async register(specialist) {
      await this.editSpecialist(specialist);
    },
    cancelForm() {
      // this.$refs.form.reset();
      this.$router.push('/especialistas');
    },
    changeSELECT() {
      this.specialist.user.document = '';
    },
    async changeDNI(valid) {
      this.valid = valid;
      this.isDocumentRegistered = false;
      if (valid) {
        const checkedSpecialist = await this.checkedInformationSpecialist(this.specialist.user.document);
        this.checkedUser(checkedSpecialist.data, this.typeDocumentSelected);
      }
    },
    async changeCarnetOrPassport(valid) {
      this.valid = valid;
      this.isDocumentRegistered = false;
      if (valid) {
        const checkedSpecialist = await this.checkedInformationSpecialist(this.specialist.user.document);
        this.checkedUserWithCarnetOrPassport(checkedSpecialist.data, this.typeDocumentSelected);
      } else {
        this.disabled_user_info = true;
      }
    },
    checkedUser(specialist, typeDocumentSelected) {
      this.clearForm();
      /* If a user with this DNI doesn't exist */
      if (specialist.user == null && specialist.userApi == null) {
        this.setNackBar('El documento ' + typeDocumentSelected + ' no existe', 'error', true);
      }
      /* If user tries to edit the document with the value of a registered document (in database) */
      if (this.valid && specialist.user != null) {
        /* If a user with this document exist. And this user is NOT a patient (registered as specialist or admin) */
        if (!specialist.isSpecialist) {
          this.ifUserRegisteredIsNotSpecialist(specialist, typeDocumentSelected);
        } else if (specialist.isSpecialist && specialist.user.uuid !== this.storedSpecialist.user.uuid) {
          /* If a user with this document exist AND this user is a specialist */
          this.ifUserRegisteredIsSpecialist(specialist, typeDocumentSelected);
        } else if (specialist.isSpecialist && specialist.user.uuid === this.storedSpecialist.user.uuid) {
          this.completeNamesLastNames(specialist.user.name, specialist.user.fatherLastname, specialist.user.motherLastname);
        }
      }
      if (this.valid && specialist.userApi !== null) {
        /* If user tries to edit the document with the value of an unregistered document (in dabtabase) */
        this.completeNamesLastNames(specialist.userApi.nombres, specialist.userApi.apellidoPaterno, specialist.userApi.apellidoMaterno);
      }
    },
    completeNamesLastNames(name, fatherLastname, motherLastname) {
      this.specialist.user.name = name;
      this.specialist.user.fatherLastname = fatherLastname;
      this.specialist.user.motherLastname = motherLastname;
    },
    checkedUserWithCarnetOrPassport(specialist, typeDocumentSelected) {
      this.clearForm();
      this.disabled_user_info = true;

      /* If a user with this DNI is not registered in BD */
      if (this.valid && specialist.user == null) {
        this.setNackBar(typeDocumentSelected + ' valido, complete los demás campos', 'primary', true);
        this.disabled_user_info = false;
      }

      /* If a user with this DNI exist. And this user is NOT a specialist */
      if (this.valid && specialist.user !== null && !specialist.isSpecialist) {
        this.ifUserRegisteredIsNotSpecialist(specialist, typeDocumentSelected);
      }
      /* If a user with this DNI exist AND this user is a specialist */
      if (this.valid && specialist.user != null && specialist.isSpecialist) {
        this.ifUserRegisteredIsSpecialist(specialist, typeDocumentSelected);
      }
    },

    /* WHEN ENTER DOCUMENT OF CLIENT SUPERVISOR, THERE´S THE POSIBILITY TO AUTOCOMPLETE ALL FIELDS  */
    ifUserRegisteredIsNotSpecialist(specialist, typeDocumentSelected) {
      // this.setNackBar(typeDocumentSelected + ' vinculado a un usuario. Complete la especialidad', 'primary', true);
      this.setNackBar(typeDocumentSelected + ' valido, complete los demás campos', 'primary', true);
      this.completeNamesLastNames(specialist.user.name, specialist.user.fatherLastname, specialist.user.motherLastname);
    },
    ifUserRegisteredIsSpecialist(specialist, typeDocumentSelected) {
      this.setNackBar('CAMBIAR ' + typeDocumentSelected + '. Ya existe un especialista registrado con el documento ingresado', 'error', true);
      this.completeNamesLastNames(specialist.user.name, specialist.user.fatherLastname, specialist.user.motherLastname);
      this.isDocumentRegistered = true;
    },
    setNackBar(text, color, show) {
      this.snackBar.text = text;
      this.snackBar.show = show;
      this.snackBar.color = color;
    },
    clearForm() {
      this.specialist.user.name = '';
      this.specialist.user.fatherLastname = '';
      this.specialist.user.motherLastname = '';
    },
  },
};
</script>
